#! /bin/bash
if [ -z "$1" ]
then
	echo "tell me file or directory name"
	exit 1
fi

argname=$1
echo "$argname"
name=`echo "$argname" | sed 's/\/$//'| sed 's/.*\///'`
dirname=`echo "$argname" | sed 's/\/$//'| sed 's/[^\/]*$//'`

function create {
	echo "create"
#	tar cvf - $argname | gzip -c -9 > $name.tar.gz
#	tar cvfz $name.tar.gz $argname
	cd $dirname ; tar cvfz $name.tar.gz $name
	return ;
	}

function ex-or-test-gz
	{
	if gunzip -t $argname
	then
		flag=z
	fi
	tar vft$flag $argname
	echo "Test finished. Do you really want to extract?"
	echo -n " (y/n)>"
	read reply
	if [ "$reply" = y ]
	then
		cd $dirname ; tar vfx$flag $name
	else
		exit 1
	fi
	return ;
	}

function ex-or-test-bz
	{
		bunzip2 -c $argname | tar vt ;
		echo "Test finished. Do you really want to extract?"
		echo -n " (y/n)>"
		read reply
		if [ "$reply" = y ]
		then
			cd $dirname ; bunzip2 -c $argname | tar vx
		else
			exit 1
		fi
		return ;
	}

if [ -d $argname ]
then
	create
else
case $1 in
	*tar.bz2)
		ex-or-test-bz ;;
	*)
		ex-or-test-gz ;;	
esac
fi
